//+------------------------------------------------------------------+
//|                                                 PipeTrader 20pip |
//|                                                www.forex-tsd.com |
//|                                                            mikep |
//+------------------------------------------------------------------+

#property copyright "System by PipeTrader, programmed by mikep"

//This version uses the following logic:
//For the first trade, the StepMA must cross AND the Force Index must exceed the threshold AT THE TIME OF THE STEPMA CROSS
//If the Force Index does not exceed the threshold, the EA will check the next candle.  If that candle has a FI greater than
//the threshold, then a trade will be opened.

//Additional entries after the MA Cross need the FI to cross over threshold and stay for two candles prior to entry
//-e.g. for a buy: candle 1 below 0.03, candle 2 above 0.03, candle 3 above 0.03, enter at opening of candle 4

//Exits are as per Post #  71 @ http://www.forex-tsd.com/suggestions-trading-systems/5847-my-simple-20-pips-8.html
//Because of this exit style I've disabled take profit

extern int MagicNumber = 0;
extern string ExpertName = "PipeTrader_SafeMode";
extern bool SignalMail = False;
extern bool EachTickMode = True;
extern double Lots = 1.0;
extern int Slippage = 3;
extern bool StopLossMode = True;
extern int StopLoss = 50;
extern bool TakeProfitMode = false;
extern int TakeProfit = 0;
extern bool TrailingStopMode = false;
extern int TrailingStop = 0;
extern double ForceSellThreshold = -0.03;
extern double ForceBuyThreshold = 0.03;
extern bool UseHourTrade = False;
extern int FromHourTrade = 0;
extern int ToHourTrade = 23;

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

int BarCount;
int Current;
bool TickCheck = False;

static bool ITradedOnThisBar;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() 
{
   if (UseHourTrade){
      if (!(Hour()>=FromHourTrade && Hour()<=ToHourTrade)) {
         Comment("Time for trade has not come else!");
         return(0);
      }
   }
{
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;



   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;

   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+

      
double StepMAUp11=iCustom(NULL,Period(),"N_StepMA_1_Email",7,1,0,500,false,0,1);
double StepMAUp12=iCustom(NULL,Period(),"N_StepMA_1_Email",7,1,0,500,false,0,2);
double StepMAUp13=iCustom(NULL,Period(),"N_StepMA_1_Email",7,1,0,500,false,0,3);
double StepMADown21=iCustom(NULL,Period(),"N_StepMA_1_Email",7,1,0,500,false,1,1);
double StepMADown22=iCustom(NULL,Period(),"N_StepMA_1_Email",7,1,0,500,false,1,2);
double StepMADown23=iCustom(NULL,Period(),"N_StepMA_1_Email",7,1,0,500,false,1,3);
double Force1=iForce(NULL,30,13,MODE_SMA,PRICE_CLOSE,1);
double Force2=iForce(NULL,30,13,MODE_SMA,PRICE_CLOSE,2);
double Force3=iForce(NULL,30,13,MODE_SMA,PRICE_CLOSE,3);



   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+

   //Check position
   bool IsTrade = False;

   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         IsTrade = True;
         if(ITradedOnThisBar != Bars)
{

         if(OrderType() == OP_BUY) {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+

               if ((StepMAUp12>=StepMADown22 && StepMAUp11<StepMADown21)||(Force3>ForceBuyThreshold && Force2>ForceBuyThreshold && Force1>ForceBuyThreshold && Force3>Force2 && Force2>Force1)) Order = SIGNAL_CLOSEBUY;

            //+------------------------------------------------------------------+
            //| Signal End(Exit Buy)                                             |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         } else {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+

               if ((StepMAUp12<=StepMADown22 && StepMAUp11>StepMADown21)||(Force3<ForceSellThreshold && Force2<ForceSellThreshold && Force1<ForceSellThreshold && Force3<Force2 && Force2<Force1)) Order = SIGNAL_CLOSESELL;

            //+------------------------------------------------------------------+
            //| Signal End(Exit Sell)                                            |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
      }
   }
   }

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+

      if ((StepMAUp12<=StepMADown22 && StepMAUp11>StepMADown21 && Force1>ForceBuyThreshold) || (StepMAUp13<=StepMADown23 && StepMAUp12>StepMADown22 && StepMAUp11>StepMADown21 && Force2<ForceBuyThreshold && Force1>ForceBuyThreshold) || (StepMAUp11>StepMADown21 && Force3<=ForceBuyThreshold && Force2>ForceBuyThreshold && Force1>ForceBuyThreshold)) Order = SIGNAL_BUY;
      if ((StepMAUp12>=StepMADown22 && StepMAUp11<StepMADown21 && Force1<ForceSellThreshold) || (StepMAUp13>=StepMADown23 && StepMAUp12<StepMADown22 && StepMAUp11<StepMADown21 && Force2>ForceSellThreshold && Force1<ForceSellThreshold) || (StepMAUp11<StepMADown21 && Force3>=ForceSellThreshold && Force2<ForceSellThreshold && Force1<ForceSellThreshold)) Order = SIGNAL_SELL;

   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+
if(ITradedOnThisBar != Bars)
{
   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (StopLossMode) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
         if (TakeProfitMode) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, ExpertName, MagicNumber, 0, DodgerBlue);
         ITradedOnThisBar = Bars;
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (StopLossMode) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
         if (TakeProfitMode) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, ExpertName, MagicNumber, 0, DeepPink);
         ITradedOnThisBar = Bars;
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("SELL order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
			} else {
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }
}
   if (!EachTickMode) BarCount = Bars;

   return(0);
}
}
//+------------------------------------------------------------------+